﻿using Syncfusion.Calculate;
using System;
using System.Data;
using System.Web.UI;

namespace Web_FQC
{
    public partial class _Default : Page
    {       
        protected void Page_Load(object sender, EventArgs e)
        {
        }
        #region Events Handling
        protected void btnMoreRows_Click(object sender, EventArgs e)
        {
            try
            {
                DataTable dt = new DataTable("Test");
                dt.Columns.Add("Sum", typeof(decimal));
                dt.Rows.Add(5);
                dt.Rows.Add(1);
                dt.Rows.Add(51);
                dt.Rows.Add(52);
                dt.Rows.Add(52);
                dt.Rows.Add(52);
                dt.Rows.Add(56);
                dt.Rows.Add(56);
                dt.Rows.Add(57);
                dt.Rows.Add(57);
                CalcSheet quartSheet = GetCalcSheetForSumColumn(dt);
                divMessage.InnerHtml = @"Formula =QUARTILE(A1:A4,0) <br/> Result :" + CalculateQuartile(quartSheet, 0)
                      + "<br/> Formula =QUARTILE(A1:A4,1) <br/> Result :" + CalculateQuartile(quartSheet, 1)
                      + "<br/> Formula =QUARTILE(A1:A4,2) <br/> Result :" + CalculateQuartile(quartSheet, 2)
                      + "<br/>Formula =QUARTILE(A1:A4,3) <br/> Result :" + CalculateQuartile(quartSheet, 3)
                      + "<br/> Formula =QUARTILE(A1:A4,4) <br/> Result :" + CalculateQuartile(quartSheet, 4);

            }
            catch (Exception)
            {
                //Block used for Write Logs.
                throw;
            }
        }

        protected void btnSingle_Click(object sender, EventArgs e)
        {
            try
            {
                DataTable dtSingle = new DataTable("Test");
                dtSingle.Columns.Add("Sum", typeof(decimal));
                dtSingle.Rows.Add(3.541);
                CalcSheet oCalcSheet = GetCalcSheetForSumColumn(dtSingle);
                divMessage.InnerHtml = @"Formula =QUARTILE(A1:A4,0) <br/> Result :" + CalculateQuartile(oCalcSheet, 0)
             + "<br/> Formula =QUARTILE(A1:A4,1) <br/> Result :" + CalculateQuartile(oCalcSheet, 1)
             + "<br/> Formula =QUARTILE(A1:A4,2) <br/> Result :" + CalculateQuartile(oCalcSheet, 2)
             + "<br/>Formula =QUARTILE(A1:A4,3) <br/> Result :" + CalculateQuartile(oCalcSheet, 3)
             + "<br/> Formula =QUARTILE(A1:A4,4) <br/> Result :" + CalculateQuartile(oCalcSheet, 4);
            }
            catch (Exception)
            {
                //Block used for Write Logs.
                throw;
            }

        }
        #endregion
        #region Business Function/Logic.
        /// <summary>
        /// Function is used for convert DataTable to CalcSheet Object.
        /// </summary>
        /// <param name="dt"></param>
        /// <returns></returns>
        private CalcSheet GetCalcSheetForSumColumn(DataTable dt)
        {
            CalcSheet oSheet = new CalcSheet(dt.Rows.Count, dt.Columns.Count);
            try
            {
                int rowCounter = 0;
                string currentValue = string.Empty;
                foreach (DataRow dr in dt.Rows)
                {
                    rowCounter++;
                    foreach (DataColumn dc in dt.Columns)
                    {
                        currentValue = dr[dc].ToString();
                        oSheet[rowCounter, dc.Ordinal + 1] = currentValue;
                    }
                }
            }
            catch (Exception)
            {
                throw;
            }
            return oSheet;
        }
        /// <summary>
        /// Function is used to calculate Mean.
        /// </summary>
        /// <param name="oSheet"></param>
        /// <returns>String Value </returns>
        private string CalculateMean(CalcSheet oSheet)
        {
            try
            {
                string result = string.Empty;
                string formulaString = string.Empty;
                formulaString = "A1:" + char.ConvertFromUtf32(64 + oSheet.ColCount) + oSheet.RowCount.ToString();
                Syncfusion.Calculate.CalcEngine.ResetSheetFamilyID();
                Syncfusion.Calculate.CalcEngine engine = new Syncfusion.Calculate.CalcEngine(oSheet);
                result = engine.ComputeAvg(formulaString);
                engine.Dispose();
                return (result);
            }
            catch (Exception)
            {
                //Block used for Write Logs.
                throw;
            }

        }
        /// <summary>
        /// Function is used to Calculate Quartile.
        /// </summary>
        /// <param name="oSheet"></param>
        /// <param name="QuartileSeq"></param>
        /// <returns></returns>
        private string CalculateQuartile(CalcSheet oSheet, int QuartileSeq)
        {
            try
            {
                string formulaString = "A1:" + char.ConvertFromUtf32(64 + oSheet.ColCount) + oSheet.RowCount.ToString() + "," + QuartileSeq.ToString();
                string resultQ = "";
                Syncfusion.Calculate.CalcEngine.ResetSheetFamilyID();
                Syncfusion.Calculate.CalcEngine engine = new Syncfusion.Calculate.CalcEngine(oSheet);
                resultQ = engine.ComputeQuartile(formulaString);
                engine.Dispose();
                return resultQ;
            }
            catch (Exception)
            {
                //Block used for Write Logs.
                throw;
            }

        }
        #endregion
    }
}